- name: Configure Azure cluster and install kubectl
  hosts: localhost
  connection: local
  gather_facts: true
  
  vars:
    azure_client_id: "048fc998-3940-4e53-a328-e8a613b9ffc9"
    azure_client_secret: "bO68Q~R5yd_991od6JW6~EpFklnhqSTPBuzZgadR"
    azure_tenant_id: "0b578d97-bb35-4c75-863a-9280b97ff86e"
    azure_cluster_name: "aks1"
    azure_resource_group: "example-resources"
    azure_location: "Central US"

  tasks:
    - name: Install Azure CLI
      apt:
        name: azure-cli
        state: present
      when: ansible_facts['distribution'] == "Debian"

    - name: Log into Azure
      command: az login --service-principal -u "{{ azure_client_id }}" -p "{{ azure_client_secret }}" --tenant "{{ azure_tenant_id }}"
      environment:
        AZURE_CLIENT_ID: "{{ azure_client_id }}"
        AZURE_CLIENT_SECRET: "{{ azure_client_secret }}"
        AZURE_TENANT_ID: "{{ azure_tenant_id }}"

    - name: Get Kubernetes credentials using Azure CLI
      command: az aks get-credentials --resource-group "{{ azure_resource_group }}" --name "{{ azure_cluster_name }}"
    
    - name: install pre-requisites
      pip:
        name:
        - openshift
        - pyyaml
        - kubernetes 

    - name: Create Argo CD namespace
      kubernetes.core.k8s:
        state: present
        api_version: v1
        kind: Namespace
        name: argocd

    - name: Apply Argo CD manifests
      kubernetes.core.k8s:
        state: present
        src: https://raw.githubusercontent.com/argoproj/argo-cd/stable/manifests/install.yaml
        namespace: argocd

    - name: Install ArgoCD CLI
      ansible.builtin.shell: |
        curl -sSL -o /usr/local/bin/argocd https://github.com/argoproj/argo-cd/releases/latest/download/argocd-linux-amd64
        chmod +x /usr/local/bin/argocd
      become: true
    
    
    - name: Create a Deployment for frontend
      kubernetes.core.k8s:
        state: present
        src: "argocd.yaml"
    - name: GET IP
      command: >
        kubectl patch svc argocd-server -n argocd --type='json' -p='[{"op": "replace", "path": "/spec/type", "value": "LoadBalancer"}]'
    
    - name: Pause for 15 seconds
      ansible.builtin.wait_for:
        timeout: 15
        state: absent

    - name: Get Argo CD server IP address
      command: kubectl -n argocd get service argocd-server -o=jsonpath={.status.loadBalancer.ingress[0].ip}
      register: argocd_server_ip

    - name: Argocd server
      debug:
        msg: "Argo CD server IP address: {{ argocd_server_ip.stdout }}"

    - name: Pause for 30 seconds
      ansible.builtin.wait_for:
        timeout: 30
        state: absent
    - name: Argocd password
      command: kubectl -n argocd get secret argocd-initial-admin-secret -o=jsonpath="{.data.password}"
      register: password_raw

    - name: Decode password
      set_fact:
        decoded_password: "{{ password_raw.stdout | b64decode }}"

    - name: Argocd password debyg
      debug:
        msg: "Argo CD password: {{ decoded_password }}"

    - name: Argocd Login
      ansible.builtin.shell: "argocd login  {{ argocd_server_ip.stdout }} --username admin --password {{ decoded_password }} --insecure"
    
    - name: Add ArgoCD repository
      ansible.builtin.command: >
        argocd repo add https://gitlab.com/berry.othmane/ecom-app-k8s.git --username "berry.othmane" --password "glpat-Vpfirf1XRk8ELrtGyzvq" 